 /**************************************************************************
  *                                                                        *
  *               Copyright (C) 1996, Silicon Graphics, Inc.               *
  *                          All Rights Reserved.                          *
  *                                                                        *
  *  The files in this subtree  contain  UNPUBLISHED  PROPRIETARY  SOURCE  *
  *  CODE of Silicon Graphics, Inc.;  the  contents  of  these  files may  *
  *  not be disclosed to third  parties,  copied  or  duplicated  in  any  *
  *  form, in whole or in part,  without  the  prior  written  permission  * 
  *  of  Silicon Graphics, Inc.                                            *
  *                                                                        *
  *  RESTRICTED RIGHTS LEGEND:                                             *
  *  Use,  duplication  or  disclosure  by  the  Government is subject to  *
  *  restrictions as set forth in subdivision (c)(1)(ii) of the Rights in  *
  *  Technical Data and Computer Software clause at  DFARS  252.227-7013,  *
  *  and/or in similar or successor  clauses in the FAR,  DOD or NASA FAR  *
  *  Supplement.  Unpublished - rights reserved  under the Copyright Laws  *
  *  of the United States.                                                 *
  *                                                                        *
  *  THIS SOFTWARE IS  PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,  *
  *  EXPRESS,  IMPLIED OR  OTHERWISE,  INCLUDING  WITHOUT LIMITATION, ANY  *
  *  WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.      *
  *                                                                        *
  *  IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,  *
  *  INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF  ANY  KIND,  OR ANY  *
  *  DAMAGES WHATSOEVER RESULTING FROM LOSS  OF  USE,  DATA  OR  PROFITS,  *
  *  WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY  *
  *  THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR  *
  *  PERFORMANCE OF THIS SOFTWARE.                                         *
  **************************************************************************/

/*
    Author : Paul Haeberli
*/

#include <stdio.h>
#include <stdlib.h>
#include <gl/image.h>

/*---------------------------------------------------------------------------*/
/*	fromcpack
/*---------------------------------------------------------------------------*/
fromcpack( char *map, int xsize, int ysize, char *outfile )
{
 int	x,y,z;
 unsigned short
	*sbuf = (unsigned short *)malloc( xsize*sizeof(short) ),
	*sptr = sbuf;
 char	*cptr;
 IMAGE	*image = iopen( outfile, "w", RLE(1), 3, xsize, ysize, 4 );

 printf( "fromcpack: %d %d\n", xsize, ysize );
 if (image == NULL) return 0;

 cptr = (char *)map;
 for (z=0; z<4; z++)
 {
	cptr = map + z;
	for (y=0; y<ysize; y++)
	{
		for (x=0; x<xsize; x++)
		{
			*sptr++ = *cptr;
			cptr += 4;
		}
/*
		cpack format : 0xaabbggrr
		.rgba format : z=0 red z=1 green z=2 blue z=3 alpha
*/
		putrow(image, sbuf, y, 3-z);
		sptr = sbuf;
	}
 }

 iclose( image );
 free( sbuf );
 return 1;
}

/*---------------------------------------------------------------------------*/
/*	tocpack
/*---------------------------------------------------------------------------*/
unsigned short rbuf[8192];
unsigned short gbuf[8192];
unsigned short bbuf[8192];
tocpack( char *map, int xsize, int ysize, char *infile )
{
 int	x,y,z;
 IMAGE	*image = iopen( infile, "r", RLE(1), 3, xsize, ysize, 4 );

 printf( "tocpack: %d %d\n", xsize, ysize );
 if (image == NULL)
 {
	printf("can't open file %s\n", infile );
	return 0;
 }

 for (y=0; y<ysize; y++)
 {
/*
	cpack format : 0xaabbggrr
	.rgba format : z=0 red z=1 green z=2 blue z=3 alpha
*/
	getrow(image, rbuf, y, 0);
	getrow(image, gbuf, y, 1);
	getrow(image, bbuf, y, 2);
	for (x=0; x<xsize; x++)
	{
		*map++ = 255;
		*map++ = (char) bbuf[x];
		*map++ = (char) gbuf[x];
		*map++ = (char) rbuf[x];
	}
 }

 iclose( image );
 return 1;
}
